import {RANGE_NUMBER_FEATURES as e, RANGE_RATIO_FEATURES as a} from './helpers.js'
const t = {
		'media-type': 0,
		width: 1,
		height: 2,
		'aspect-ratio': 3,
		'device-width': 4,
		'device-height': 5,
		'device-aspect-ratio': 6,
		hover: 7,
		'any-hover': 8,
		pointer: 9,
		'any-pointer': 10,
		resolution: 11,
		color: 12,
		monochrome: 13,
		'color-gamut': 14,
		'video-color-gamut': 15,
		update: 16,
		scan: 17,
		'color-index': 18,
		'overflow-block': 19,
		'overflow-inline': 20,
		'prefers-color-scheme': 21,
		'prefers-contrast': 22,
		'prefers-reduced-data': 23,
		'prefers-reduced-motion': 24,
		'prefers-reduced-transparency': 25,
		'dynamic-range': 26,
		'video-dynamic-range': 27,
		'display-mode': 28,
		'nav-controls': 29,
		scripting: 30,
		'horizontal-viewport-segments': 31,
		'vertical-viewport-segments': 32,
		'forced-colors': 33,
		'inverted-colors': 34,
		'environment-blending': 35,
		grid: 36
	},
	r = (e, a) => (0 === a ? e : r(a, e % a)),
	o = (e, a) => {
		if (!Number.isInteger(e) || !Number.isInteger(a)) return [e, a]
		const t = r(e > a ? e : a, e > a ? a : e)
		return [e / t, a / t]
	},
	n = e => Number.parseFloat(e.toFixed(5))
export const featurePairToEnglishQuerySegments = t => {
	if ('media-type' === t[0]) {
		let e = 'is screen'
		return (
			'print' === t[1]
				? (e = 'printing')
				: 'not-print' === t[1]
				? (e = 'not printing')
				: 'not-screen' === t[1] && (e = 'not a screen'),
			[{type: 'type', value: e}]
		)
	}
	if ('color' === t[0]) {
		const [, , a, r] = e[t[0]].bounds,
			[o, n, p, l] = t[1],
			i = n > 1 || (1 === n && !0 > o),
			u = p < a || (p === a && r > l),
			s = []
		return (
			n === p && o && l
				? 0 === n && o && (p > 0 || l)
					? s.push({type: 'plain', value: 'not in color'})
					: s.push(
							{type: 'feature', value: t[0]},
							{type: 'comparison', value: '='},
							{type: 'plain', value: 3 * n + '-bit'}
					  )
				: (i || u || s.push({type: 'plain', value: 'in'}),
				  i &&
						s.push(
							{type: 'plain', value: 3 * n + '-bit'},
							{type: 'comparison', value: o ? '≤' : '<'}
						),
				  s.push({type: 'feature', value: t[0]}),
				  u &&
						s.push(
							{type: 'comparison', value: l ? '≤' : '<'},
							{type: 'plain', value: `${3 * p}-bit${i ? '' : ' or not in color'}`}
						)),
			s
		)
	}
	if ('monochrome' === t[0]) {
		const [, , a, r] = e[t[0]].bounds,
			[o, n, p, l] = t[1],
			i = 0 === n && o && (p > 0 || l),
			u = n > 1 || (1 === n && !0 > o),
			s = p < a || (p === a && r > l),
			v = []
		return (
			n === p && o && l
				? i ||
				  v.push(
						{type: 'feature', value: t[0]},
						{type: 'plain', value: 'and pixels'},
						{type: 'comparison', value: '='},
						{type: 'plain', value: `${n}-bit`}
				  )
				: (i && v.push({type: 'paren', value: '('}),
				  v.push({type: 'plain', value: 'monochrome'}),
				  (u || s) &&
						(v.push({type: 'plain', value: 'and'}),
						u &&
							v.push(
								{type: 'plain', value: `${n}-bit`},
								{type: 'comparison', value: o ? '≤' : '<'}
							),
						v.push({type: 'plain', value: 'pixels'}),
						s &&
							v.push(
								{type: 'comparison', value: l ? '≤' : '<'},
								{type: 'plain', value: `${p}-bit`}
							),
						i &&
							v.push(
								{type: 'bool-op', value: 'OR'},
								{type: 'plain', value: 'not monochrome'},
								{type: 'paren', value: ')'}
							))),
			v
		)
	}
	if (
		'color-index' === t[0] ||
		'device-height' === t[0] ||
		'device-width' === t[0] ||
		'height' === t[0] ||
		'width' === t[0] ||
		'resolution' === t[0] ||
		'horizontal-viewport-segments' === t[0] ||
		'vertical-viewport-segments' === t[0]
	) {
		const [a, r, o, p] = e[t[0]].bounds,
			[l, i, u, s] = t[1],
			v = i > r || (i === r && a > l),
			c = u < o || (u === o && p > s),
			y = {type: 'never', value: 'never'}
		if (v) {
			y.type = 'dimension'
			let a = 'px'
			'integer' === e[t[0]].type
				? ((y.type = 'number'), (a = ''))
				: 'resolution' === e[t[0]].type && (a = 'x'),
				(y.value = `${n(i)}${a}`)
		}
		const f = {type: 'never', value: 'never'}
		if (c) {
			f.type = 'dimension'
			let a = 'px'
			'integer' === e[t[0]].type
				? ((f.type = 'number'), (a = ''))
				: 'resolution' === e[t[0]].type && (a = 'x'),
				(f.value = `${n(u)}${a}`)
		}
		const d = []
		return (
			i === u && l && s
				? d.push({type: 'feature', value: t[0]}, {type: 'comparison', value: '='}, f)
				: (v && d.push(y, {type: 'comparison', value: l ? '≤' : '<'}),
				  d.push({type: 'feature', value: t[0]}),
				  c && d.push({type: 'comparison', value: s ? '≤' : '<'}, f)),
			d
		)
	}
	if ('aspect-ratio' === t[0] || 'device-aspect-ratio' === t[0]) {
		const [e, r, p, l] = a[t[0]].bounds,
			i = r[0] / r[1],
			u = p[0] / p[1],
			[s, v, c, y] = t[1],
			f = v[0] / v[1],
			d = c[0] / c[1],
			m = f > i || (f === i && e > s),
			h = d < u || (d === u && l > y),
			g = 'aspect-ratio' === t[0] ? 'is' : 'device is'
		if (1 === f && 1 === d && s && y) return [{type: 'plain', value: `${g} square`}]
		if (1 === f && !h) return [{type: 'plain', value: `${g} landscape${s ? ' or square' : ''}`}]
		if (1 === d && !m) return [{type: 'plain', value: `${g} portrait${y ? ' or square' : ''}`}]
		const b = {type: 'ratio', value: `${o(n(v[0]), n(v[1])).join(':')}`},
			w = {type: 'ratio', value: `${o(n(c[0]), n(c[1])).join(':')}`},
			R = []
		return (
			f === d && s && y
				? R.push({type: 'feature', value: t[0]}, {type: 'comparison', value: '='}, w)
				: (m && R.push(b, {type: 'comparison', value: s ? '≤' : '<'}),
				  R.push({type: 'feature', value: t[0]}),
				  h && R.push({type: 'comparison', value: y ? '≤' : '<'}, w)),
			R
		)
	}
	if ('any-hover' === t[0] || 'hover' === t[0])
		return 'hover' === t[0]
			? [
					{
						type: 'plain',
						value: 'primary input ' + ('hover' === t[1] ? 'supports' : "doesn't support")
					},
					{type: 'feature', value: 'hover'}
			  ]
			: [{type: 'plain', value: ('hover' === t[1] ? 'an' : 'no') + ' input supports hover'}]
	if ('any-pointer' === t[0] || 'pointer' === t[0])
		return 'pointer' === t[0]
			? [
					{
						type: 'plain',
						value:
							'none' === t[1]
								? 'no pointing device'
								: 'primary pointing device is ' + ('fine' === t[1] ? 'precise' : 'imprecise')
					}
			  ]
			: [
					{
						type: 'plain',
						value:
							'none' === t[1]
								? 'no pointing device'
								: 'a pointing device is ' + ('fine' === t[1] ? 'precise' : 'imprecise')
					}
			  ]
	if ('grid' === t[0])
		return [
			{
				type: 'plain',
				value: 0 === t[1] ? "doesn't use terminal as display" : 'uses terminal as display'
			}
		]
	if ('scan' === t[0])
		return [
			{
				type: 'plain',
				value:
					'interlace' === t[1] ? 'on alternating frame screen' : 'on non-alternating frame screen'
			}
		]
	if ('update' === t[0])
		return [
			{
				type: 'plain',
				value:
					'none' === t[1]
						? 'layout cannot update after render'
						: 'layout should update ' + ('slow' === t[1] ? 'slowly' : 'quickly')
			}
		]
	if ('color-gamut' === t[0] || 'video-color-gamut' === t[0]) {
		const e = (t[1][3] ? 1 : 0) + (t[1][2] ? 2 : 0) + (t[1][1] ? 4 : 0) + (t[1][0] ? 8 : 0),
			a = ((r = t[0]),
			[
				[{type: 'never', value: 'never'}],
				[
					{type: 'plain', value: 'Rec. 2020'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r}
				],
				[
					{type: 'plain', value: 'P3'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'Rec. 2020'}
				],
				[
					{type: 'plain', value: 'P3'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r}
				],
				[
					{type: 'plain', value: 'sRGB'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'P3'}
				],
				[
					{type: 'plain', value: 'sRGB'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'P3'},
					{type: 'bool-op', value: 'or'},
					{type: 'plain', value: 'Rec. 2020'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r}
				],
				[
					{type: 'plain', value: 'sRGB'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'Rec. 2020'}
				],
				[
					{type: 'plain', value: 'sRGB'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r}
				],
				[
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'sRGB'}
				],
				[
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'sRGB'},
					{type: 'bool-op', value: 'or'},
					{type: 'plain', value: 'Rec. 2020'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r}
				],
				[
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'sRGB'},
					{type: 'bool-op', value: 'or'},
					{type: 'plain', value: 'P3'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'Rec. 2020'}
				],
				[
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'sRGB'},
					{type: 'bool-op', value: 'or'},
					{type: 'plain', value: 'P3'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r}
				],
				[
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'P3'}
				],
				[
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'P3'},
					{type: 'bool-op', value: 'or'},
					{type: 'plain', value: 'Rec. 2020'},
					{type: 'comparison', value: '≤'},
					{type: 'feature', value: r}
				],
				[
					{type: 'feature', value: r},
					{type: 'comparison', value: '<'},
					{type: 'feature', value: 'Rec. 2020'}
				],
				[{type: 'never', value: 'never'}]
			])[e]
		return a.some(e => 'bool-op' === e.type && 'or' === e.value)
			? [{type: 'paren', value: '('}, ...a, {type: 'paren', value: ')'}]
			: a
	}
	return 'overflow-block' === t[0]
		? [
				{
					type: 'plain',
					value:
						'none' === t[1]
							? 'cannot view vertical overflow'
							: 'can view vertical overflow ' + ('scroll' === t[1] ? 'by scrolling' : 'as pages')
				}
		  ]
		: 'overflow-inline' === t[0]
		? [
				{
					type: 'plain',
					value:
						'none' === t[1]
							? 'cannot view horizontal overflow'
							: 'can view horizontal overflow ' + ('scroll' === t[1] ? 'by scrolling' : 'as pages')
				}
		  ]
		: 'display-mode' === t[0]
		? [
				{
					type: 'plain',
					value:
						'fullscreen' === t[1]
							? 'is fullscreen'
							: 'standalone' === t[1]
							? 'is a native-looking application'
							: 'minimal-ui' === t[1]
							? 'is a browser with reduced UI'
							: 'is a browser with full browser UI'
				}
		  ]
		: 'dynamic-range' === t[0] || 'video-dynamic-range' === t[0]
		? [{type: 'plain', value: 'standard' === t[1] ? 'SDR' : 'HDR'}]
		: 'environment-blending' === t[0]
		? [
				{
					type: 'plain',
					value:
						'opaque' === t[1]
							? 'shown on opaque medium'
							: 'additive' === t[1]
							? 'shown on additive medium'
							: 'shown on subtractive medium'
				}
		  ]
		: 'forced-colors' === t[0]
		? [
				{
					type: 'plain',
					value: 'none' === t[1] ? 'no forced color palette' : 'user has forced a color palette'
				}
		  ]
		: 'nav-controls' === t[0]
		? [
				{
					type: 'plain',
					value: 'none' === t[1] ? 'has no obvious back button' : 'has obvious back button'
				}
		  ]
		: 'inverted-colors' === t[0]
		? [
				{
					type: 'plain',
					value: 'none' === t[1] ? 'screen has not inverted colors' : 'screen has inverted colors'
				}
		  ]
		: 'scripting' === t[0]
		? [
				{
					type: 'plain',
					value:
						'none' === t[1]
							? 'JavaScript disabled'
							: 'initial-only' === t[1]
							? 'JavaScript disabled after load'
							: 'JavaScript enabled'
				}
		  ]
		: 'prefers-color-scheme' === t[0]
		? [{type: 'plain', value: 'light' === t[1] ? 'prefers light mode' : 'prefers dark mode'}]
		: 'prefers-contrast' === t[0]
		? [
				{
					type: 'plain',
					value:
						'no-preference' === t[1]
							? 'no contrast preferences'
							: 'less' === t[1]
							? 'prefers less contrast'
							: 'more' === t[1]
							? 'prefers more contrast'
							: 'has custom contrast preferences'
				}
		  ]
		: 'prefers-reduced-data' === t[0]
		? [
				{
					type: 'plain',
					value: 'no-preference' === t[1] ? 'no preference for reduced data' : 'prefers less data'
				}
		  ]
		: 'prefers-reduced-motion' === t[0]
		? [
				{
					type: 'plain',
					value:
						'no-preference' === t[1] ? 'no preference for reduced motion' : 'prefers less motion'
				}
		  ]
		: [
				{
					type: 'plain',
					value:
						'no-preference' === t[1]
							? 'no preference for reduced transparency'
							: 'prefers less transparency'
				}
		  ]
	var r
}
export const toEnglishData = e => {
	const a = e.simplePerms.map(e => {
		const a = []
		for (const r in e) {
			const o = r
			a[t[o]] = [o, e[o]]
		}
		return a.filter(Boolean)
	})
	let r = !1
	const o = []
	for (const e of a) {
		const a = []
		for (const t of e) {
			const e = featurePairToEnglishQuerySegments(t)
			a.length > 0 && e.length > 0 && a.push({type: 'bool-op', value: 'and'}), a.push(...e)
		}
		0 === a.length && (r = !0), o.push(a)
	}
	return {
		querySegmentLists: r ? [[{type: 'always', value: 'always'}]] : o,
		invalidFeatures: e.invalidFeatures,
		falseFeatures: e.falseFeatures
	}
}
const p = e => {
	if (0 === e.length) return ''
	{
		const a = e.slice(-1)
		return ' ' === a || '(' === a ? e : e + ' '
	}
}
export const toEnglishString = e => {
	const a = toEnglishData(e)
	if (0 === a.querySegmentLists.length) return 'never'
	let t = !1,
		r = 'if'
	for (const e of a.querySegmentLists) {
		let a = ''
		for (const t of e) {
			if ('always' === t.type) return 'always'
			if ('never' === t.type)
				throw new Error('Unexpected never found, report issue with media-query-fns')
			'bool-op' === t.type
				? (a = p(a) + t.value.toUpperCase())
				: 'paren' === t.type && ')' === t.value
				? (a += ')')
				: (a = p(a) + t.value)
		}
		t && (r = p(r) + 'OR'), (r = a.includes(' AND ') ? p(r) + '(' + a + ')' : p(r) + a), (t = !0)
	}
	return r
}
