import { EvaluateResult } from "./compile.js";
type Integer = number;
export type Environment = {
    mediaType: "screen" | "print" | "not-screen-or-print";
    anyHover: "none" | "hover";
    anyPointer: "none" | "coarse" | "fine";
    colorGamut: "not-srgb" | "srgb-but-not-p3" | "p3-but-not-rec2020" | "rec2020";
    grid: "bitmap" | "grid";
    hover: "none" | "hover";
    overflowBlock: "none" | "scroll" | "paged";
    overflowInline: "none" | "scroll";
    pointer: "none" | "coarse" | "fine";
    scan: "interlace" | "progressive";
    update: "none" | "slow" | "fast";
    widthPx: Integer;
    heightPx: Integer;
    deviceWidthPx: Integer;
    deviceHeightPx: Integer;
    colorBits: Integer;
    monochromeBits: "not-monochrome" | Integer;
    colorIndex: "none" | Integer;
    dppx: Integer;
    displayMode: "fullscreen" | "standalone" | "minimal-ui" | "browser";
    dynamicRange: "not-hdr" | "hdr";
    environmentBlending: "opaque" | "additive" | "subtractive";
    forcedColors: "none" | "active";
    invertedColors: "none" | "inverted";
    navControls: "none" | "back";
    prefersColorScheme: "no-preference" | "light" | "dark";
    prefersContrast: "no-preference" | "less" | "more" | "custom";
    prefersReducedData: "no-preference" | "reduce";
    prefersReducedMotion: "no-preference" | "reduce";
    prefersReducedTransparency: "no-preference" | "reduce";
    scripting: "none" | "initial-only" | "enabled";
    videoColorGamut: "not-srgb" | "srgb-but-not-p3" | "p3-but-not-rec2020" | "rec2020";
    videoDynamicRange: "not-hdr" | "hdr";
    horizontalViewportSegments: Integer;
    verticalViewportSegments: Integer;
};
type DefaultableFeatures = "mediaType" | "anyHover" | "anyPointer" | "colorGamut" | "grid" | "hover" | "overflowBlock" | "overflowInline" | "pointer" | "scan" | "update" | "colorIndex" | "colorBits" | "monochromeBits" | "displayMode" | "dynamicRange" | "environmentBlending" | "forcedColors" | "invertedColors" | "navControls" | "prefersColorScheme" | "prefersContrast" | "prefersReducedData" | "prefersReducedMotion" | "prefersReducedTransparency" | "scripting" | "videoColorGamut" | "videoDynamicRange" | "horizontalViewportSegments" | "verticalViewportSegments";
export declare const DESKTOP_ENVIRONMENT: Pick<Environment, DefaultableFeatures>;
export declare const validateEnv: (env: Environment) => void;
export declare const matches: (compiledQuery: EvaluateResult, environment: Omit<Environment, DefaultableFeatures> & Partial<Pick<Environment, DefaultableFeatures>>) => boolean;
export {};
